//+------------------------------------------------------------------+
//|                      Rate of Change for Multi Currency Pairs.mq4 |                                     |
//|                                              Ernst van der Merwe |
//+------------------------------------------------------------------+
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 7

extern int TimeFrame=0;  //1=1minute;5=5minutes;15=15minutes;30=30minutes;60=1Hour;240=4Hour;1440=Daily; 

extern double level1= 6000;
extern double level2= 4000; 
extern double level3= 2000;
extern double level4=-2000; 
extern double level5=-4000;
extern double level6=-6000; 
//---- indicator buffers
double  ROC_AUD[];
double  ROC_CAD[];
double  ROC_CHF[];
double  ROC_EUR[];
double  ROC_GBP[];
double  ROC_USD[];
double  ROC_JPY[];


string pair1="AUD";
string pair2="CAD";
string pair3="CHF";
string pair4="EUR";
string pair5="GBP";
string pair6="USD";
string pair7="JYP";



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetLevelStyle(STYLE_DOT,1,LightSlateGray); 
   SetLevelValue(0,level1); 
   SetLevelValue(1,level2); 
   SetLevelValue(2,level3); 
   SetLevelValue(3,level4); 
   SetLevelValue(4,level5); 
   SetLevelValue(5,level6); 
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,Orange);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1,White);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1,Red);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1,Blue);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1,Gray);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1,Purple);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1,Yellow);
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,0);
   SetIndexDrawBegin(1,0);
   SetIndexDrawBegin(2,0);
   SetIndexDrawBegin(3,0);
   SetIndexDrawBegin(4,0);
   SetIndexDrawBegin(5,0);
   SetIndexDrawBegin(6,0);
//---- 
   SetIndexBuffer(0,ROC_AUD);
   SetIndexBuffer(1,ROC_CAD);
   SetIndexBuffer(2,ROC_CHF);
   SetIndexBuffer(3,ROC_EUR);
   SetIndexBuffer(4,ROC_GBP);
   SetIndexBuffer(5,ROC_USD);
   SetIndexBuffer(6,ROC_JPY);

//---- 
   switch(TimeFrame)
     {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="";
     }
   IndicatorShortName("ROC "+TimeFrameStr);
   SetIndexLabel(0,pair1);
   SetIndexLabel(1,pair2);
   SetIndexLabel(2,pair3);
   SetIndexLabel(3,pair4);
   SetIndexLabel(4,pair5);
   SetIndexLabel(5,pair6);
   SetIndexLabel(6,pair7);

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  
   double  AUDCADP = MarketInfo("AUDCAD",MODE_POINT);
   double  AUDCHFP = MarketInfo("AUDCHF",MODE_POINT);
   double  EURAUDP = MarketInfo("EURAUD",MODE_POINT);
   double  GBPAUDP = MarketInfo("GBPAUD",MODE_POINT); 
   double  AUDUSDP = MarketInfo("AUDUSD",MODE_POINT); 
   double  AUDJPYP = MarketInfo("AUDJPY",MODE_POINT); 
   double  CADCHFP = MarketInfo("CADCHF",MODE_POINT); 
   double  CADJPYP = MarketInfo("CADJPY",MODE_POINT); 
   double  CHFJPYP = MarketInfo("CHFJPY",MODE_POINT); 
   double  EURCADP = MarketInfo("EURCAD",MODE_POINT);
   double  EURCHFP = MarketInfo("EURCHF",MODE_POINT);
   double  EURGBPP = MarketInfo("EURGBP",MODE_POINT);
   double  EURJPYP = MarketInfo("EURJPY",MODE_POINT);
   double  EURUSDP = MarketInfo("EURUSD",MODE_POINT);
   double  GBPCADP = MarketInfo("GBPCAD",MODE_POINT); 
   double  GBPCHFP = MarketInfo("GBPCHF",MODE_POINT); 
   double  GBPUSDP = MarketInfo("GBPUSD",MODE_POINT); 
   double  GBPJPYP = MarketInfo("GBPJPY",MODE_POINT); 
   double  USDCADP = MarketInfo("USDCAD",MODE_POINT); 
   double  USDCHFP = MarketInfo("USDCHF",MODE_POINT); 
   double  USDJPYP = MarketInfo("USDJPY",MODE_POINT); 
       
   
   int      i,limit=1000;

   double   AUD[1000];
   double   CAD[1000];
   double   CHF[1000];
   double   EUR[1000];
   double   GBP[1000];
   double   USD[1000];
   double   JPY[1000];
 




 



 JPY[i]=0;
 
 

   int   limitAUD=ArraySize(AUD);
   ArraySetAsSeries(AUD,false);
   for(i=0; i<limitAUD; i++)
{
AUD[i]=0;
AUD[i] = AUD[i]+((iOpen("AUDCAD",TimeFrame,i)- iOpen("AUDCAD",TimeFrame,i+288))/AUDCADP) ;
AUD[i] = AUD[i]+((iOpen("AUDCHF",TimeFrame,i)- iOpen("AUDCHF",TimeFrame,i+288))/AUDCHFP) ;
AUD[i] = AUD[i]-((iOpen("EURAUD",TimeFrame,i)- iOpen("EURAUD",TimeFrame,i+288))/EURAUDP) ;
AUD[i] = AUD[i]-((iOpen("GBPAUD",TimeFrame,i)- iOpen("GBPAUD",TimeFrame,i+288))/GBPAUDP) ;
AUD[i] = AUD[i]+((iOpen("AUDUSD",TimeFrame,i)- iOpen("AUDUSD",TimeFrame,i+288))/AUDUSDP) ;
AUD[i] = AUD[i]+((iOpen("AUDJPY",TimeFrame,i)- iOpen("AUDJPY",TimeFrame,i+288))/AUDJPYP) ;
}

for(i=limit-1; i>=0; i--)
{
ROC_AUD[i]=AUD[i];
}
 int   limitCAD=ArraySize(CAD);
   ArraySetAsSeries(CAD,false);
   for(i=0; i<limitCAD; i++)
{

CAD[i]=0;
CAD[i] = CAD[i]-((iOpen("AUDCAD",TimeFrame,i)- iOpen("AUDCAD",TimeFrame,i+288))/AUDCADP) ;
CAD[i] = CAD[i]+((iOpen("CADCHF",TimeFrame,i)- iOpen("CADCHF",TimeFrame,i+288))/CADCHFP) ;
CAD[i] = CAD[i]-((iOpen("EURCAD",TimeFrame,i)- iOpen("EURCAD",TimeFrame,i+288))/EURCADP) ;
CAD[i] = CAD[i]-((iOpen("GBPCAD",TimeFrame,i)- iOpen("GBPCAD",TimeFrame,i+288))/GBPCADP) ;
CAD[i] = CAD[i]-((iOpen("USDCAD",TimeFrame,i)- iOpen("USDCAD",TimeFrame,i+288))/USDCADP) ;
CAD[i] = CAD[i]+((iOpen("CADJPY",TimeFrame,i)- iOpen("CADJPY",TimeFrame,i+288))/CADJPYP) ;
}

for(i=limit-1; i>=0; i--)
{
ROC_CAD[i]=CAD[i];
}  

int   limitCHF=ArraySize(CHF);
   ArraySetAsSeries(CHF,false);
   for(i=0; i<limitCHF; i++)
{
CHF[i]=0;
CHF[i] = CHF[i]-((iOpen("AUDCHF",TimeFrame,i)- iOpen("AUDCHF",TimeFrame,i+288))/AUDCHFP) ;
CHF[i] = CHF[i]-((iOpen("CADCHF",TimeFrame,i)- iOpen("CADCHF",TimeFrame,i+288))/CADCHFP) ;
CHF[i] = CHF[i]-((iOpen("EURCHF",TimeFrame,i)- iOpen("EURCHF",TimeFrame,i+288))/EURCHFP) ;
CHF[i] = CHF[i]-((iOpen("GBPCHF",TimeFrame,i)- iOpen("GBPCHF",TimeFrame,i+288))/GBPCHFP) ;
CHF[i] = CHF[i]-((iOpen("USDCHF",TimeFrame,i)- iOpen("USDCHF",TimeFrame,i+288))/USDCHFP) ;
CHF[i] = CHF[i]+((iOpen("CHFJPY",TimeFrame,i)- iOpen("CHFJPY",TimeFrame,i+288))/CHFJPYP) ;
}

for(i=limit-1; i>=0; i--)
{
ROC_CHF[i]=CHF[i];
}  

int   limitEUR=ArraySize(EUR);
   ArraySetAsSeries(EUR,false);
   for(i=0; i<limitEUR; i++)
{
EUR[i]=0;
EUR[i] = EUR[i]+((iOpen("EURAUD",TimeFrame,i)- iOpen("EURAUD",TimeFrame,i+288))/EURAUDP) ;
EUR[i] = EUR[i]+((iOpen("EURCAD",TimeFrame,i)- iOpen("EURCAD",TimeFrame,i+288))/EURCADP) ;
EUR[i] = EUR[i]+((iOpen("EURCHF",TimeFrame,i)- iOpen("EURCHF",TimeFrame,i+288))/EURCHFP) ;
EUR[i] = EUR[i]+((iOpen("EURGBP",TimeFrame,i)- iOpen("EURGBP",TimeFrame,i+288))/EURGBPP) ;
EUR[i] = EUR[i]+((iOpen("EURUSD",TimeFrame,i)- iOpen("EURUSD",TimeFrame,i+288))/EURUSDP) ;
EUR[i] = EUR[i]+((iOpen("EURJPY",TimeFrame,i)- iOpen("EURJPY",TimeFrame,i+288))/EURJPYP) ;
}

for(i=limit-1; i>=0; i--)
{
ROC_EUR[i]=EUR[i];
} 

int   limitGBP=ArraySize(GBP);
   ArraySetAsSeries(GBP,false);
   for(i=0; i<limitGBP; i++)
{
GBP[i]=0;
GBP[i] = GBP[i]+((iOpen("GBPAUD",TimeFrame,i)- iOpen("GBPAUD",TimeFrame,i+288))/GBPAUDP) ;
GBP[i] = GBP[i]+((iOpen("GBPCAD",TimeFrame,i)- iOpen("GBPCAD",TimeFrame,i+288))/GBPCADP) ;
GBP[i] = GBP[i]+((iOpen("GBPCHF",TimeFrame,i)- iOpen("GBPCHF",TimeFrame,i+288))/GBPCHFP) ;
GBP[i] = GBP[i]-((iOpen("EURGBP",TimeFrame,i)- iOpen("EURGBP",TimeFrame,i+288))/EURGBPP) ;
GBP[i] = GBP[i]+((iOpen("GBPUSD",TimeFrame,i)- iOpen("GBPUSD",TimeFrame,i+288))/GBPUSDP) ;
GBP[i] = GBP[i]+((iOpen("GBPJPY",TimeFrame,i)- iOpen("GBPJPY",TimeFrame,i+288))/GBPJPYP) ;
}

for(i=limit-1; i>=0; i--)
{
ROC_GBP[i]=GBP[i];
} 

int   limitUSD=ArraySize(USD);
   ArraySetAsSeries(USD,false);
   for(i=0; i<limitUSD; i++)
{
USD[i]=0;
USD[i] = USD[i]-((iOpen("AUDUSD",TimeFrame,i)- iOpen("AUDUSD",TimeFrame,i+288))/AUDUSDP) ;
USD[i] = USD[i]+((iOpen("USDCAD",TimeFrame,i)- iOpen("USDCAD",TimeFrame,i+288))/USDCADP) ;
USD[i] = USD[i]+((iOpen("USDCHF",TimeFrame,i)- iOpen("USDCHF",TimeFrame,i+288))/USDCHFP) ;
USD[i] = USD[i]-((iOpen("EURUSD",TimeFrame,i)- iOpen("EURUSD",TimeFrame,i+288))/EURUSDP) ;
USD[i] = USD[i]-((iOpen("GBPUSD",TimeFrame,i)- iOpen("GBPUSD",TimeFrame,i+288))/GBPUSDP) ;
USD[i] = USD[i]+((iOpen("USDJPY",TimeFrame,i)- iOpen("USDJPY",TimeFrame,i+288))/USDJPYP) ;
}

for(i=limit-1; i>=0; i--)
{
ROC_USD[i]=USD[i];
} 

int   limitJPY=ArraySize(JPY);
   ArraySetAsSeries(JPY,false);
   for(i=0; i<limitJPY; i++)
{
JPY[i]=0;
JPY[i] = JPY[i]-((iOpen("AUDJPY",TimeFrame,i)- iOpen("AUDJPY",TimeFrame,i+288))/AUDJPYP) ;
JPY[i] = JPY[i]-((iOpen("CADJPY",TimeFrame,i)- iOpen("CADJPY",TimeFrame,i+288))/CADJPYP) ;
JPY[i] = JPY[i]-((iOpen("CHFJPY",TimeFrame,i)- iOpen("CHFJPY",TimeFrame,i+288))/CHFJPYP) ; 
JPY[i] = JPY[i]-((iOpen("EURJPY",TimeFrame,i)- iOpen("EURJPY",TimeFrame,i+288))/EURJPYP) ;
JPY[i] = JPY[i]-((iOpen("GBPJPY",TimeFrame,i)- iOpen("GBPJPY",TimeFrame,i+288))/GBPJPYP) ;
JPY[i] = JPY[i]-((iOpen("USDJPY",TimeFrame,i)- iOpen("USDJPY",TimeFrame,i+288))/USDJPYP) ;
}

for(i=limit-1; i>=0; i--)
{
ROC_JPY[i]=JPY[i];
} 

//---- done
   return(0);
  }